pro do_hotpixsub_p3,refimage,refimage_short,specimage,specimage_short, $
                    refdark_long,refdark_short,refdark_long_pre,refdark_short_pre,refdark_combined, $
                    flicker_mask,hotpix_mask,$
                    hotpix=hotpix
  
  irc_imcombine_n,refdark_long,refdark_short,refdark_combined,/no_shift,comb_mode='median',rmsimage=sigma_dark_long
  irc_imcombine_n,refdark_long_pre,refdark_short_pre,refdark_combined,/no_shift,comb_mode='median'
  
  fac_flicker_thresh=3.
  
  if !IRC_SPECRED_MISC.flicker_thresh LE 0 then begin
     m=moment(sigma_dark_long[*,*,1],/nan)
     flicker_thresh=sqrt(m[1])*fac_flicker_thresh
  endif else flicker_thresh=!IRC_SPECRED_MISC.flicker_thresh
  print,flicker_thresh,!IRC_SPECRED_MISC.flicker_thresh
  
  flicker_mask=sigma_dark_long[*,*,1] & flicker_mask[*,*]=1.
  flicker=where(sigma_dark_long[*,*,1] GT flicker_thresh,count)
  
;    fac=2.
;    flicker=where((sigma_dark_long[*,*,1]/sqrt(abs(refdark_combined[*,*,1])) GT fac AND refdark_combined[*,*,1] GT 4.^2.) OR (sigma_dark_long[*,*,1] GT 4.*fac AND refdark_combined[*,*,1] LE 4.^2.),count)
  
  if count GT 0 then flicker_mask[flicker]=!values.f_nan
  print,'fraction of flickering pixel: ',count/(512.*412.)*100.
  
  fac_hotpix_thresh=3.
  
  if !IRC_SPECRED_MISC.hot_thresh LE 0 then begin
     m=moment(refdark_combined[*,*,1],/nan)
     hotpix_thresh=sqrt(m[1])*fac_hotpix_thresh
  endif else hotpix_thresh=!IRC_SPECRED_MISC.hot_thresh
  print,hotpix_thresh,!IRC_SPECRED_MISC.hot_thresh
  
  hotpix_mask=sigma_dark_long[*,*,1] & hotpix_mask[*,*]=1.
  
  hotpix=where(refdark_combined[*,*,1] GT hotpix_thresh,count)
  if count GT 0 then hotpix_mask[hotpix]=!values.f_nan
  print,'fraction of hot pixel (%): ',count/(512.*412.)*100.
  print,hotpix_thresh
  
  hotpix=flicker_mask*hotpix_mask
  hotpix_image=flicker_mask*hotpix_mask
  
; check correlation between hotpixel and noisypixel
;     plot,sqrt(refdark_combined[*,*,1]),sigma_dark_long[*,*,1],psym=3,color=0,/xlog,xr=[1e-0,1e3],/ylog,yr=[1e-0,1e3]
;     oplot,findgen(1000),findgen(1000),color=3
;     oplot,[hotpix_thresh,hotpix_thresh],[0.1,1e3],color=3
;     oplot,[0.1,1e3],[flicker_thresh,flicker_thresh],color=3


;     window,xsize=800,ysize=800
;     plot,sqrt(refdark_combined[*,*,1]),sigma_dark_long[*,*,1],psym=3,color=0,/xlog,xr=[1e-0,1e1],/ylog,yr=[1e-0,1e1],xtitle='sqrt(dark [ADU])',ytitle='sigma_dark [ADU]'
;     oplot,[sqrt(hotpix_thresh),sqrt(hotpix_thresh)],[0.1,1e3],color=3
;     oplot,[0.1,100.],[flicker_thresh,flicker_thresh],color=3

;
;     hotbutstable=where(refdark_combined[*,*,1] GT hotpix_thresh AND sigma_dark_long[*,*,1] LE flicker_thresh,count)
;     print,'# of hot but stable pixel: ',count

;     hist_refdark_combined_mask=histogram(refdark_combined[*,*,1]*flicker_mask,bin=1,min=0,max=1000)
;     hist_refdark_combined     =histogram(refdark_combined[*,*,1],             bin=1,min=0,max=1000)
;     plot, hist_refdark_combined_mask,color=0,/ylog,yr=[1,1e4]
;     oplot,hist_refdark_combined,     color=1

end
